Bug 888163 - efivarfs i_nlink underflows during unlinking
Summary: efivarfs i_nlink underflows during unlinking
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: kernel
Version: 18
Hardware: x86_64
OS: Linux
unspecified
unspecified
Target Milestone: ---
Assignee: Kernel Maintainer List
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2012-12-18 07:12 UTC by Lingzhu Xiang
Modified: 2013-07-04 20:56 UTC (History)
7 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-01-14 04:14:54 UTC
Type: Bug


Attachments (Terms of Use)

Description Lingzhu Xiang 2012-12-18 07:12:06 UTC
Description of problem:

[root@localhost ~]# mount -t efivarfs - /sys/firmware/efi/efivars/
[root@localhost ~]# ls -1 /sys/firmware/efi/efivars/ | wc -l
28
[root@localhost ~]# stat -c%h /sys/firmware/efi/efivars/
2
[root@localhost ~]# rm -f /sys/firmware/efi/efivars/*
[   41.690805] ------------[ cut here ]------------
[   41.692975] WARNING: at fs/inode.c:280 drop_nlink+0x46/0x50()
[   41.694546] Modules linked in: nf_conntrack_netbios_ns nf_conntrack_broadcast ipt_MASQUERADE ip6table_mangle ip6t_REJECT nf_conntrack_ipv6 nf_defrag_ipv6 ip6table_filter ip6_tables iptable_nat nf_nat iptable_mangle nf_conntrack_ipv4 nf_defrag_ipv4 xt_conntrack nf_conntrack vfat fat i2c_piix4 i2c_core microcode virtio_net
[   41.701583] Pid: 822, comm: rm Tainted: G        W    3.6.11-3.fc18.x86_64.debug #1
[   41.703008] Call Trace:
[   41.703499]  [<ffffffff8106781f>] warn_slowpath_common+0x7f/0xc0
[   41.704591]  [<ffffffff8106787a>] warn_slowpath_null+0x1a/0x20
[   41.705777]  [<ffffffff811eb266>] drop_nlink+0x46/0x50
[   41.706855]  [<ffffffff81553fca>] efivarfs_unlink+0x8a/0xd0
[   41.707952]  [<ffffffff811dd75e>] vfs_unlink+0x9e/0x110
[   41.710800]  [<ffffffff811dd90d>] do_unlinkat+0x13d/0x1a0
[   41.712096]  [<ffffffff810d6b6d>] ? trace_hardirqs_on_caller+0x10d/0x1a0
[   41.713808]  [<ffffffff8110181c>] ? __audit_syscall_entry+0xcc/0x300
[   41.714983]  [<ffffffff8134f50e>] ? trace_hardirqs_on_thunk+0x3a/0x3f
[   41.716548]  [<ffffffff811e025b>] sys_unlinkat+0x1b/0x50
[   41.717694]  [<ffffffff816e7fe9>] system_call_fastpath+0x16/0x1b
[   41.718995] ---[ end trace 33f799b901d1db9e ]---
[root@localhost ~]# ls -1 /sys/firmware/efi/efivars/ | wc -l
15
[root@localhost ~]# stat -c%h /sys/firmware/efi/efivars/
4294967285

Version-Release number of selected component (if applicable):
3.6.11-3.fc18.x86_64.debug
3.7.0-2.fc19.x86_64

How reproducible:
Always reproduced on QEMU.

Comment 1 Josh Boyer 2012-12-18 14:20:31 UTC
What are you using for a QEMU image?  Default KVM/QEMU images don't have EFI emulated.

Comment 2 Lingzhu Xiang 2012-12-19 01:49:05 UTC
(In reply to comment #1)
> What are you using for a QEMU image?  Default KVM/QEMU images don't have EFI
> emulated.

James Bottomley's OVMF. OVMF-0.1+r13902-1.1.x86_64.rpm. 

qemu-kvm -enable-kvm -nodefaults -nographic -cpu host -smp 2 -m 2048 -bios /usr/share/qemu-ovmf/bios/bios.bin -drive file=root-fedora-18-Beta.raw,if=ide,cache=none,aio=native -net nic,model=virtio -net user -serial stdio

Btw, I figure there are a series of more bugs in efivarfs. Please tell me when it becomes better to report upstream.

Comment 3 Josh Boyer 2012-12-19 02:22:54 UTC
(In reply to comment #2)
> (In reply to comment #1)
> > What are you using for a QEMU image?  Default KVM/QEMU images don't have EFI
> > emulated.
> 
> James Bottomley's OVMF. OVMF-0.1+r13902-1.1.x86_64.rpm. 
> 
> qemu-kvm -enable-kvm -nodefaults -nographic -cpu host -smp 2 -m 2048 -bios
> /usr/share/qemu-ovmf/bios/bios.bin -drive
> file=root-fedora-18-Beta.raw,if=ide,cache=none,aio=native -net
> nic,model=virtio -net user -serial stdio

OK.  I'll see if I can recreate tomorrow with that.  Thank you.

> Btw, I figure there are a series of more bugs in efivarfs. Please tell me
> when it becomes better to report upstream.

Now would be a good time to report upstream.  The efivarfs filesystem was just merged for the 3.8 kernel, and we're still before 3.8-rc1 so getting issues fixed upstream before 3.8 is released would be very good.

Comment 4 Josh Boyer 2013-01-07 16:25:58 UTC
I've added your patch to f18 and rawhide.  Many thanks for working through this.

Comment 5 Fedora Update System 2013-01-08 19:53:03 UTC
kernel-3.7.1-5.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/kernel-3.7.1-5.fc18

Comment 6 Fedora Update System 2013-01-09 22:52:13 UTC
Package kernel-3.7.1-5.fc18:
* should fix your issue,
* was pushed to the Fedora 18 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing kernel-3.7.1-5.fc18'
as soon as you are able to, then reboot.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2013-0518/kernel-3.7.1-5.fc18
then log in and leave karma (feedback).

Comment 7 Fedora Update System 2013-01-12 15:06:39 UTC
kernel-3.7.2-201.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/kernel-3.7.2-201.fc18

Comment 8 Fedora Update System 2013-01-14 04:14:56 UTC
kernel-3.7.2-201.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.